#define ASM
#define STANDALONE
#include "h1011e/hardware.h"

#ifndef CMD
	.sect data_x,sci_defaults
	/*SCI_MODE	0xC000*/
	/*SCI_STATUS	0xC001*/
	.org SCI_BASS
#ifdef LOUDNESS_ON
#ifdef BASS_VAL
	.uword BASS_VAL	/*SCI_BASS	0xC002*/
#else
	.uword 0x33d9
#endif
#else
	.uword 0x0000	/*SCI_BASS	0xC002*/
#endif
	.uword CLOCKF_VAL	/*SCI_CLOCKF	0xC003*/
	.uword 0x0000	/*SCI_DECODE_TIME 0xC004*/
	.uword 0x0000	/*SCI_AUDATA	0xC005*/
	.uword 0x0000	/*SCI_WRAM	0xC006*/ /* REC gain/AGC -> AICTRL1*/
	.uword 0xFFFF	/*SCI_WRAMADDR	0xC007*/ /* REC max gain -> AICTRL2*/
	.uword 0x0000	/*SCI_HDAT0	0xC008*/
	.uword 0x0000	/*SCI_HDAT1	0xC009*/
	.uword 0x0000	/*SCI_AIADDR	0xC00A*/
#ifdef VOL_VAL
	.uword VOL_VAL	/*SCI_VOL	0xC00B*/
#else
	.uword 0x0c0c	/*SCI_VOL	0xC00B*/
#endif /*VOL_VAL !defined*/
	.uword 0	/*SCI_AICTRL0	0xC00C*/ /* file to play */
	.uword 0	/*SCI_AICTRL1	0xC00D*/
#ifdef BASS_VAL
	.uword BASS_VAL	/*SCI_AICTRL2	0xC00E -- loudness value for non-sci */
#else
	.uword 0x33d9	/*SCI_AICTRL2	0xC00E -- loudness value for non-sci */
#endif
#if 1
	.uword 0x0000	/*SCI_AICTRL3	0xC00F*/
#else
	.uword 0x0004	/*SCI_AICTRL3	0xC00F pause before play */
#endif

#endif /*!SCI_UI*/

	.sect code,MySdi
	.org 0x10		// space for 16 instructions
	.export _SciModeOr
_SciModeOr:
	jr
#ifdef ENABLE_LAYER12
	ldc (1<<SCIMB_SDI_NEWMODE)|(MODEORMASK)|(1<<SCIMB_ALLOW_LAYER12),a0
#else
	ldc (1<<SCIMB_SDI_NEWMODE)|(MODEORMASK),a0
#endif/*ENABLE_LAYER12*/
	//nop
	//nop

	.import _UserHook
hooK:	j _UserHook

#ifndef SCI_UI
	.export my_sdi_int
my_sdi_int:
	stx mr0,(i6)+1	; sty i7,(i6)
	stx a0,(i6)	; sty b0,(i6)

	ldc SER_DATA,i7
	lsr ones,b0	; ldx (i7),a0
	.import _ui
	ldc _ui+0/*Data*/,i7
	lsrc a0,a0	; ldy (i6),b0		// 0x8000 or 0xffff;

	sty a0,(i7)	; ldx (i6)-1,a0

	ldc INT_GLOB_ENA,i7
	ldx (i6),mr0
	reti
	stx i7,(i7); ldy (i6)-1,i7


	/* SDI vector updated AFTER the handler is loaded, thus is ok */
	.sect code,int_vectors
	.org 0x22
	jmpi my_sdi_int,(i6)+1	// SDI	0x22
#endif/*!SCI_UI*/

	.import __stack
	.sect code,startup
	.org 0x30

#ifdef SCI_UI
#define NO_START_DELAY
#endif
#ifdef ENABLE_LAYER12
#define NO_START_DELAY
#endif

	.import _ReadFromProgramRam
	.import _WriteToProgramRam
#ifdef SCI_UI
#ifdef NO_START_DELAY
	// Install the idle hook routine 
	// WriteToProgramRamLong(0, ReadFromProgramRam(0x14));
	call _ReadFromProgramRam
	ldc hooK,i0
	call _WriteToProgramRam
	ldc 0,i0

	ldc 1,a1	// perform full init
#else
	ldc 0x48d0,LS	//0x0030  0x0012340e      LDC 0x48d0,LS 22.75ms
			//0x0030  0x003fff0e      LDC 0xfffc,LS	80.00ms
	loop LS,$0-1
	nop
	call _ReadFromProgramRam	//$48d0*(5+5+5) cycles = 22.75ms
	ldc hooK,i0
	call _WriteToProgramRam
	ldc 0,i0
	ldc 1,a1	// perform full init
$0:
#endif
#endif/*SCI_UI*/

	.import _MyMain
	.export _MyReset
	j _MyMain
_MyReset:
	ldc __stack,i6
	j _MyMain
	ldc 0,a1	// perform partial init

#ifndef SCI_UI
	.sect code,hook
	.org 0
	j _UserHook
#endif


#ifdef SWITCH_CS2_AND_SCLK
#define GPIO_IDATA GPIO_DATA
#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   8
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
#define SPI_xCS2  2
#define SPI_MOSI  1 /* DREQ */
#else
#define GPIO_IDATA GPIO_DATA
#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   2
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
#define SPI_xCS2  8
#define SPI_MOSI  1 /* DREQ */
#endif
	.sect code,SpiSendClocks
	.export _SpiSendClocks
_SpiSendClocks:
// auto void SpiSendClocks(void);
	stx ls,(i6)+1	; sty le,(i6)

	ldc 1,i5
	ldc SER_DREQ,i7
	stx i5,(i7)+(GPIO_ODATA-SER_DREQ) ; sty lc,(i6)	// data out (=1)
	ldc 16-1,ls
	loop ls,$0-1
	nop

	j $10	// 3 cycles
$10:	ldc SPI_CLK|SPI_xCS|SPI_xCS2,i5
	stx i5,(i7)	// clk up

	j $11	// 3 cycles
$11:	ldc SPI_xCS|SPI_xCS2,i5
	stx i5,(i7)	// clk down
	//nop	//VS1003 seems to require this
$0:
	ldy (i6)-1,lc
	jr
	ldx (i6)-1,ls	; ldy (i6),le
	//Normally loop hw can not be restored in JR delay slot,
	//but we know that SpiSendClocks is not called from HW loop


#if 1
	.sect code,SpiSendReceiveSpi
	.export _SpiSendReceiveSpi
_SpiSendReceiveSpi:
// auto u_int16 SpiSendReceiveSpi(register __a0 u_int16 dataTopAligned, register __a1 bits);
	stx d0,(i6)+1	; sty c0,(i6)
	ldc SPI_xCS2,c0	//SPI CLK up, SPI CS down, MMC CLK down
	j _SpiCommon
	ldc 0,d0	//SPI CLK down. SPI CS down, MMC CLK down
#endif
	.sect code,SpiSendReceiveMmc
	.export _SpiSendReceiveMmc16
	.export _SpiSendReceiveMmc
_SpiSendReceiveMmc16:
	ldc 16,A1
_SpiSendReceiveMmc:
// auto u_int16 SpiSendReceiveMmc(register __a0 u_int16 dataTopAligned, register __a1 bits);
	// A0 = 16-bit data to send, A0 = data read
	// I7, A1, D1 tmp regs
	stx d0,(i6)+1	; sty c0,(i6)
	ldc SPI_CLK|SPI_xCS,c0	//MMC CLK up, SPI CS up
	ldc SPI_xCS,d0		//MMC CLK down, SPI CS up
_SpiCommon:
	stx lc,(i6)+1	; sty c1,(i6)
	add a1,ones,c1	; stx ls,(i6)
	lsl a,a		; sty le,(i6)
	ldc SER_DREQ,i7

	loop c1,$0-1
	ldc SPI_MISO_SHIFT,c1
$1:
	// PLL2_0  66/33% clock 4.1 MHz
	//=2.0*12.288/6 = 4.096
	// 2.0*12.288/7 = 3.511

	nop // as much delay between clk down and data i/o as possible
	stx a1,(i7)+(GPIO_IDATA-SER_DREQ)	//data out
	ldx (i7)+(GPIO_ODATA-GPIO_IDATA),a1	//data in, note pipeline!
	stx c0,(i7)+(GPIO_ODATA-GPIO_ODATA) // clk up   ODATA
	ashl a1,c1,a1
	lslc a,a	; stx d0,(i7)+(SER_DREQ-GPIO_ODATA)	// clk down
$0:
	ldx (i6)-1,ls	; ldy (i6),le
	ldx (i6)-1,lc	; ldy (i6),c1
	jr
	ldx (i6)-1,d0	; ldy (i6),c0

// DO DI Clkup Clkdwn



// auto u_int16 GetByte(register __c0 u_int16 n) {
//     return (stream_buffer[n>>1] >> (((n^1)&1)<<3)) & 0xff;

	.sect code,GetByte	// 28 words -> 11
	.export _GetByte
_GetByte:
	stx lr0,(i6)+1	; sty c1,(i6)	// 11->6 words
	call _GetWord
	ldc 0xff,c1
	ldx (i6),lr0
	jr
	and c1,a0,a0	; ldy (i6)-1,c1

//auto u_int16 GetWord(register u_int16 n) {
//    return GetByte(n) | (GetByte(n+1)<<8);

// auto u_int32 GetLong(register __c0 u_int16 n) {
//     return GetWord(n) | ((u_int32)GetWord(n+2)<<16);

	.sect code,GetLong	// 22 words -> 9 -> 6 -> 5
	.export _GetLong
	.export _GetWord
_GetLong:
	sub c0,ones,a1	; sty lr0,(i6)
	call _GetWord
	sub a1,ones,c0	; stx c0,(i6)+1
	ldy (i6),lr0
	//j _GetWord
	add a0,null,a1	; ldx (i6),c0
_GetWord:			// 22 words -> 16
	.import _stream_buffer
	ldc _stream_buffer,i5
	lsr c0,a0	; stx i4,(i6)
	mv a0,i4
	ldx (i5)*,null	; sty a1,(i6)
	ldx (i5)+1,a1		// abcd
	ldc 8,c0
	jcc $0
	ldx (i5),a0		// abcd efgh

	ashl a,c0,a		// cdef gh00
$0:
	ldc 0,a2
	sub null,c0,c0	; mv a2,a0	//8 -> -8
	ashl a,c0,a	; ldx (i6),i4	// 0 00cd ef00
	jr
	or a1,a0,a0	; ldy (i6)-1,a1	//        efcd




	.sect data_y,bss_y
	.export _fileName
_fileName:
	.bss 6
#ifndef NO_RANDOM
	.export _rand_seed
_rand_seed:
	.bss 1		// the initial seed is 1 (K&R p.252), we have uninit..

	.sect code,_myrand
/* Returns a pseudo-random integer in the range 0 to RAND_MAX */
	.export _myrand
_myrand:
	ldc _rand_seed,i7
	ldy (i7),a0	; stx a1,(i6)
	ldc 16217,a1		//0x4001,a0
	mulss a0,a1
	ldc 9043,a0		//0x951,a0
	add a,p,a		// x(n+1) = (a*x(n)+c) mod m
	jr
	sty a0,(i7)	; ldx (i6)-1,a1	// output: 0..0xffff
#endif/*!NO_RANDOM*/


#ifndef SCI_UI
// u_int16 ClockSdi(void) {
	.sect code,ClockSdi	// 20 words
	.export _ClockSdi
_ClockSdi:
#if 1
	ldc 32-1,A0
	ldc SER_DREQ,I7
$0:	ldc 1,I5	// for timing
	add A0,ONES,A0	; stx I5,(I7)
	ldc 0,I5	// for timing
	jnc $0
	stx I5,(I7)
	jr
	nop
#else
	/* does not work -- returns too fast after STX?! */
	ldc 32-1,A0
	ldc SER_DREQ,I7
$0:	ldc 1,I5	// for timing
	add A0,ONES,A0	; stx I5,(I7)
	ldc 0,I5	// for timing
	jrns
	stx I5,(I7)
	jmpi $0
#endif
#endif

#ifdef ENABLE_LAYER12
#ifdef MP2_PATCH
	.import _bitindex,_wordpointer,_c1,_applAddr
	.import _ReadFrame,_play_frame

	.sect code,code
	.export _Mp2Patch
_Mp2Patch:
$0:
//       if (!ReadFrame())
//          play_frame();

	ldc 0x4a3b,le
	ldc $1,ls
	call _ReadFrame		//auto s_int16 ReadFrame(void);
	ldc 1,lc
	
	add A0,NULL,A0	; ldx (I6)+1,NULL
	ldc _bitindex,I7
	jzc $0
	ldc $0,lr0

//   bitindex = 0;
//   wordpointer = c1.bsbuf+c1.bsOffset;

	ldc _c1+3,I0	// field bsbuf, offset 3
	ldy (I0)+1,B0
	and a0,null,a0	; ldy (I0),A1	//a0 already 0, but clear anyway..
	//ldc _wordpointer,I0 //wordpointer = bitindex+1
	add B0,A1,B0	; sty A0,(I7)+1
	j _play_frame	//auto void play_frame(void);
	sty B0,(I7)+1	; ldx (I6)+1,NULL


$1:	// in decode_header
	// a0 = fr.lay-1 i0 = &fr.lsf
	add a0,ones,a0	//when layer2, 1->0
	ldc 0,c0
	jle 0x4a3d	//fr.lay<=2, shift by zero (c0)
	ldx (i5),a0
	j 0x4a3d	//if fr.lay>=3, shift by fr.lsf
	ldy (i0),c0
#endif /*MP2_PATCH*/
#endif /*ENABLE_LAYER12*/


	.end
